Index: cpukit/libfs/src/dosfs/msdos_misc.c
===================================================================
--- cpukit/libfs/src/dosfs/msdos_misc.c	(revision 8bed60314e383fe461c03236857b9ba369beecd4)
+++ cpukit/libfs/src/dosfs/msdos_misc.c	(revision d2e0bb36e34f1fe45641f26b8b8d6ef615963854)
@@ -9,4 +9,7 @@
  *  Copyright (C) 2001 OKTET Ltd., St.-Petersburg, Russia
  *  Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
+ *
+ *  Modifications to support UTF-8 in the file system are
+ *  Copyright (c) 2013 embedded brains GmbH.
  *
  *  The license and distribution terms for this file may be
@@ -27,4 +30,6 @@
 #include <string.h>
 #include <assert.h>
+#include <errno.h>
+#include <inttypes.h>
 #include <rtems/libio_.h>
 
@@ -70,5 +75,5 @@
 
     if ((ch == '.') || isalnum((unsigned char)ch) ||
-        (strchr("$%'-_@~`!(){}^#&", ch) != NULL))
+        (strchr("$%'-_@~`!(){}^#&", ch) != NULL) || (unsigned char) ch > 127)
         return MSDOS_NAME_SHORT;
 
@@ -193,8 +198,16 @@
 #define MSDOS_L2S_PRINT 0
 msdos_name_type_t
-msdos_long_to_short(const char *lfn, int lfn_len, char* sfn, int sfn_len)
+msdos_long_to_short(rtems_dosfs_convert_control     *converter,
+                    const char                      *lfn,
+                    int                              lfn_len,
+                    char                            *sfn,
+                    int                              sfn_len)
 {
     msdos_name_type_t type;
+    int               eno = 0;
     int               i;
+    ssize_t           short_filename_length = sfn_len;
+    void             *buffer = converter->buffer.data;
+    size_t            codepage_name_len = converter->buffer.size;
 
     /*
@@ -243,19 +256,44 @@
      */
 
-    type = msdos_name_type (lfn, lfn_len);
-
-    if (type == MSDOS_NAME_INVALID)
+    eno = (*converter->handler->utf8_to_codepage) (
+        converter,
+        (const uint8_t*)&lfn[0],
+        lfn_len,
+        buffer,
+        &codepage_name_len);
+    if (eno == EINVAL)
+    {
+        eno = 0;
+        type = MSDOS_NAME_LONG;
+    }
+    else
+    {
+        type = msdos_name_type (
+            buffer,
+            codepage_name_len);
+    }
+
+    if (type != MSDOS_NAME_INVALID)
+    {
+        short_filename_length = msdos_filename_utf8_to_short_name_for_save (
+            converter,
+            (const uint8_t*)lfn,
+            lfn_len,
+            sfn,
+            short_filename_length);
+        if (short_filename_length < 0 ) {
+            type = MSDOS_NAME_INVALID;
+        }
+#if MSDOS_L2S_PRINT
+        printf ("MSDOS_L2S: TYPE:%d lfn:'%s' SFN:'%s'\n", type, lfn, sfn);
+#endif
+    }
+    else
     {
 #if MSDOS_L2S_PRINT
         printf ("MSDOS_L2S: INVALID[2]: lfn:'%s' SFN:'%s'\n", lfn, sfn);
 #endif
-        return MSDOS_NAME_INVALID;
-    }
-
-    msdos_filename_unix2dos (lfn, lfn_len, sfn);
-
-#if MSDOS_L2S_PRINT
-    printf ("MSDOS_L2S: TYPE:%d lfn:'%s' SFN:'%s'\n", type, lfn, sfn);
-#endif
+    }
+
     return type;
 }
@@ -293,11 +331,13 @@
     memset(node_entry, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
 
-    name_type = msdos_long_to_short (name,
-                                     name_len,
-                                     MSDOS_DIR_NAME(node_entry),
-                                     MSDOS_NAME_MAX);
+    name_type = msdos_long_to_short (
+        fs_info->converter,
+        name,
+        name_len,
+        MSDOS_DIR_NAME(node_entry),
+        MSDOS_NAME_MAX);
 
     /*
-     * find the node which correspondes to the name in the directory pointed by
+     * find the node which corresponds to the name in the directory pointed by
      * 'parent_loc'
      */
@@ -427,5 +467,5 @@
     /* find name in fat-file which corresponds to the directory */
     rc = msdos_find_name_in_fat_file(parent_loc->mt_entry, fat_fd,
-                                     create_node, name, name_len, name_type,
+                                     create_node, (const uint8_t*)name, name_len, name_type,
                                      dir_pos, name_dir_entry);
     if ((rc != RC_OK) && (rc != MSDOS_NAME_NOT_FOUND_ERR))
@@ -519,4 +559,5 @@
     char             dotdot_node[MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE];
     uint32_t         cl4find = 0;
+    rtems_dosfs_convert_control *converter = fs_info->converter;
 
     /*
@@ -543,6 +584,8 @@
     /* find "." node in opened directory */
     memset(dot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-    msdos_long_to_short(".", 1, dot_node, MSDOS_SHORT_NAME_LEN);
-    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, ".", 1,
+    msdos_long_to_short(
+        converter,
+        ".", 1, dot_node, MSDOS_SHORT_NAME_LEN);
+    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, (const uint8_t*)".", 1,
                                      MSDOS_NAME_SHORT, dir_pos, dot_node);
 
@@ -555,6 +598,8 @@
     /* find ".." node in opened directory */
     memset(dotdot_node, 0, MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-    msdos_long_to_short("..", 2, dotdot_node, MSDOS_SHORT_NAME_LEN);
-    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, "..", 2,
+    msdos_long_to_short(
+        converter,
+        "..", 2, dotdot_node, MSDOS_SHORT_NAME_LEN);
+    rc = msdos_find_name_in_fat_file(mt_entry, fat_fd, false, (const uint8_t*)"..", 2,
                                      MSDOS_NAME_SHORT, dir_pos,
                                      dotdot_node);
@@ -915,88 +960,314 @@
 }
 
-/* msdos_create_name_in_fat_file --
- *     This routine creates an entry in the fat file for the file name
- *     provided by the user. The directory entry passed is the short
- *     file name and is added as it. If the file name is long a long
- *     file name set of entries is added.
- *
- *     Scan the directory for the file and if not found add the new entry.
- *     When scanning remember the offset in the file where the directory
- *     entry can be added.
+#define MSDOS_FIND_PRINT 0
+static int
+msdos_on_entry_found (
+    msdos_fs_info_t                      *fs_info,
+    fat_file_fd_t                        *fat_fd,
+    const uint32_t                        bts2rd,
+    char                                 *name_dir_entry,
+    char                                 *entry,
+    fat_dir_pos_t                        *dir_pos,
+    uint32_t                             *dir_offset,
+    const uint32_t                        dir_entry,
+    const fat_pos_t                      *lfn_start
+)
+{
+    int rc = RC_OK;
+#if MSDOS_FIND_PRINT
+    printf ("MSFS:[9.3] SNF found\n");
+#endif
+    /*
+     * We get the entry we looked for - fill the position
+     * structure and the 32 bytes of the short entry
+     */
+    rc = fat_file_ioctl(&fs_info->fat,
+                        fat_fd,
+                        F_CLU_NUM,
+                        *dir_offset * bts2rd,
+                        &dir_pos->sname.cln);
+    if (rc == RC_OK) {
+        dir_pos->sname.ofs = dir_entry;
+
+        if (lfn_start->cln != FAT_FILE_SHORT_NAME)
+        {
+            rc = fat_file_ioctl (&fs_info->fat,
+                                 fat_fd,
+                                 F_CLU_NUM,
+                                 lfn_start->cln * bts2rd,
+                                 &lfn_start->cln);
+        }
+        if ( rc == RC_OK ) {
+            dir_pos->lname.cln = lfn_start->cln;
+            dir_pos->lname.ofs = lfn_start->ofs;
+
+            memcpy(name_dir_entry, entry,
+                   MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
+        }
+    }
+
+    return rc;
+}
+
+ssize_t
+msdos_get_utf16_string_from_long_entry (
+    const char                 *entry,
+    uint16_t                   *entry_string_buf,
+    const size_t                buf_size,
+    bool                        is_first_entry
+)
+{
+    ssize_t chars_in_entry;
+
+    if (buf_size >= MSDOS_LFN_LEN_PER_ENTRY * MSDOS_NAME_LFN_BYTES_PER_CHAR) {
+        memcpy (&entry_string_buf[0],  &entry[1],  10 );
+        memcpy (&entry_string_buf[5],  &entry[14], 12 );
+        memcpy (&entry_string_buf[11], &entry[28],  4 );
+
+        if (is_first_entry) {
+            for (chars_in_entry = 0;
+                 (    entry_string_buf[chars_in_entry] != 0x0000
+                  && chars_in_entry < MSDOS_LFN_LEN_PER_ENTRY );
+                  ++chars_in_entry) {
+                ;
+            }
+        }
+        else
+            chars_in_entry = MSDOS_LFN_LEN_PER_ENTRY;
+
+        return chars_in_entry * MSDOS_NAME_LFN_BYTES_PER_CHAR;
+    }
+    else
+        return ENOMEM;
+}
+
+/*  msdos_format_dirent_with_dot --
+ *      This routine convert a (short) MSDOS filename as present on disk
+ *      (fixed 8+3 characters, filled with blanks, without separator dot)
+ *      to a "normal" format, with between 0 and 8 name chars,
+ *      a separating dot and up to 3 extension characters
+ *   Rules to work:
+ *      - copy any (0-8) "name" part characters that are non-blank
+ *      - if an extension exists, append a dot
+ *      - copy any (0-3) non-blank extension characters
+ *      - append a '\0' (dont count it for the rturn code
  *
  * PARAMETERS:
- *     mt_entry       - mount table entry
- *     fat_fd         - fat-file descriptor
- *     name           - NULL or name to find
- *     paux           - identify a node location on the disk -
- *                      number of cluster and offset inside the cluster
- *     name_dir_entry - node to create/placeholder for found node
+ *     dst: pointer to destination char array (must be big enough)
+ *     src: pointer to source characters
+ *
  *
  * RETURNS:
- *     RC_OK on success, or error code if error occured (errno set
- *     appropriately)
- *
+ *     the number of bytes (without trailing '\0'(written to destination
  */
-#define MSDOS_FIND_PRINT 0
-int msdos_find_name_in_fat_file(
-    rtems_filesystem_mount_table_entry_t *mt_entry,
+ssize_t
+msdos_format_dirent_with_dot(char *dst,const char *src)
+{
+  ssize_t len;
+  int i;
+  const char *src_tmp;
+
+  /*
+   * find last non-blank character of base name
+   */
+  for (i = MSDOS_SHORT_BASE_LEN, src_tmp = src + MSDOS_SHORT_BASE_LEN - 1;
+       i > 0 && *src_tmp == ' ';
+       --i,--src_tmp)
+    {};
+  /*
+   * copy base name to destination
+   */
+  src_tmp = src;
+  len = i;
+  while (i-- > 0) {
+    *dst++ = tolower((unsigned char)(*src_tmp++));
+  }
+  /*
+   * find last non-blank character of extension
+   */
+  for (i = MSDOS_SHORT_EXT_LEN,
+        src_tmp = src + MSDOS_SHORT_BASE_LEN+MSDOS_SHORT_EXT_LEN-1;
+       i > 0 && *src_tmp == ' ';
+       --i, --src_tmp)
+    {};
+  /*
+   * extension is not empty
+   */
+  if (i > 0) {
+    *dst++ = '.'; /* append dot */
+    ++len;        /* dot */
+    src_tmp = src + MSDOS_SHORT_BASE_LEN;
+    while (i-- > 0) {
+      *dst++ = tolower((unsigned char)(*src_tmp++));
+      ++len;
+    }
+  }
+  *dst = '\0'; /* terminate string */
+
+  return len;
+}
+
+static ssize_t
+msdos_long_entry_to_utf8_name (
+    rtems_dosfs_convert_control *converter,
+    const char                  *entry,
+    const bool                   is_first_entry,
+    uint8_t                     *entry_utf8_buf,
+    const size_t                 buf_size)
+{
+    ssize_t      retval         = 0;
+    int          eno            = 0;
+    size_t       bytes_in_utf8  = buf_size;
+    size_t       bytes_in_buf;
+    uint16_t     entry_string[MSDOS_LFN_LEN_PER_ENTRY];
+
+    retval = msdos_get_utf16_string_from_long_entry (
+        entry,
+        entry_string,
+        sizeof (entry_string),
+        is_first_entry
+    );
+
+    if (retval >= 0) {
+        bytes_in_buf = retval;
+        eno = (*converter->handler->utf16_to_utf8) (
+            converter,
+            &entry_string[0],
+            bytes_in_buf,
+            &entry_utf8_buf[0],
+            &bytes_in_utf8);
+        if ( eno == 0 ) {
+            retval = bytes_in_utf8;
+        }
+    }
+
+    if (eno != 0) {
+        retval = -1;
+        errno  = eno;
+    }
+
+    return retval;
+}
+
+static ssize_t msdos_short_entry_to_utf8_name (
+  rtems_dosfs_convert_control     *converter,
+  const char                      *entry,
+  uint8_t                         *buf,
+  const size_t                     buf_size)
+{
+  char         char_buf[MSDOS_NAME_MAX_WITH_DOT];
+  int          eno             = 0;
+  size_t       bytes_converted = buf_size;
+  ssize_t      bytes_written   = msdos_format_dirent_with_dot(char_buf, entry);
+
+  if (bytes_written > 0) {
+    if (char_buf[0] == 0x05)
+      char_buf[0] = 0xE5;
+
+    eno = (*converter->handler->codepage_to_utf8) (
+        converter,
+        char_buf,
+        bytes_written,
+        buf,
+        &bytes_converted);
+    if (eno == 0)
+        bytes_written = bytes_converted;
+  } else {
+      eno = EINVAL;
+  }
+
+  if (eno != 0) {
+      bytes_written = -1;
+      errno         = eno;
+  }
+
+  return bytes_written;
+}
+
+static ssize_t
+msdos_compare_entry_against_filename (
+    rtems_dosfs_convert_control *converter,
+    const uint8_t               *entry,
+    const size_t                 entry_size,
+    const uint8_t               *filename,
+    const size_t                 filename_size_remaining,
+    bool                        *is_matching)
+{
+  ssize_t      size_remaining = filename_size_remaining;
+  int          eno            = 0;
+  uint8_t      entry_normalized[( MSDOS_LFN_LEN_PER_ENTRY + 1 ) * MSDOS_NAME_LFN_BYTES_PER_CHAR * MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR];
+  size_t       bytes_in_entry_normalized = sizeof ( entry_normalized );
+
+  eno = (*converter->handler->utf8_normalize_and_fold) (
+      converter,
+      &entry[0],
+      entry_size,
+      &entry_normalized[0],
+      &bytes_in_entry_normalized);
+  if (eno == 0) {
+#if MSDOS_FIND_PRINT > 1
+        printf ( "MSFS:[6] entry_normalized:%s"
+                 "name:%s\n",
+                 entry,
+                 filename );
+#endif
+        if (bytes_in_entry_normalized <= size_remaining) {
+            size_remaining = size_remaining - bytes_in_entry_normalized;
+            if (0 == memcmp ( &entry_normalized[0],
+                              &filename[size_remaining],
+                              bytes_in_entry_normalized)) {
+                *is_matching = true;
+            } else {
+                *is_matching   = false;
+                size_remaining = filename_size_remaining;
+            }
+
+        }
+        else {
+          *is_matching = false;
+        }
+    }
+
+    if (eno != 0) {
+      size_remaining = -1;
+      errno          = eno;
+    }
+
+    return size_remaining;
+}
+
+static int
+msdos_find_file_in_directory (
+    const uint8_t                        *filename_converted,
+    const size_t                          name_len_for_compare,
+    const size_t                          name_len_for_save,
+    const msdos_name_type_t               name_type,
+    msdos_fs_info_t                      *fs_info,
     fat_file_fd_t                        *fat_fd,
-    bool                                  create_node,
-    const char                           *name,
-    int                                   name_len,
-    msdos_name_type_t                     name_type,
+    const uint32_t                        bts2rd,
+    const bool                            create_node,
+    const unsigned int                    fat_entries,
+    char                                 *name_dir_entry,
     fat_dir_pos_t                        *dir_pos,
-    char                                 *name_dir_entry
-                                )
-{
-    ssize_t          ret = 0;
-    msdos_fs_info_t *fs_info = mt_entry->fs_info;
-    uint32_t         dir_offset = 0;
-    uint32_t         dir_entry = 0;
-    uint32_t         bts2rd = 0;
-    fat_pos_t        lfn_start;
-    bool             lfn_matched = false;
-    uint8_t          lfn_checksum = 0;
-    int              lfn_entries;
-    int              lfn_entry = 0;
-    uint32_t         empty_space_offset = 0;
-    uint32_t         empty_space_entry = 0;
-    uint32_t         empty_space_count = 0;
-    bool             empty_space_found = false;
-    uint32_t         entries_per_block;
-    bool             read_cluster = false;
-
-    assert(name_len > 0);
-
-    fat_dir_pos_init(dir_pos);
-
-    lfn_start.cln = lfn_start.ofs = FAT_FILE_SHORT_NAME;
-
-    /*
-     * Set the number of short entries needed to store the LFN. If the name
-     * is short still check for possible long entries with the short name.
-     *
-     * In PR1491 we need to have a LFN for a short file name entry. To
-     * test this make this test always fail, ie add "0 &&".
-     */
-    if (create_node && (name_type == MSDOS_NAME_SHORT))
-      lfn_entries = 0;
-    else
-      lfn_entries =
-        ((name_len - 1) + MSDOS_LFN_LEN_PER_ENTRY) / MSDOS_LFN_LEN_PER_ENTRY;
-
-    if (FAT_FD_OF_ROOT_DIR(fat_fd) &&
-        (fs_info->fat.vol.type & (FAT_FAT12 | FAT_FAT16)))
-        bts2rd = fat_fd->fat_file_size;
-    else
-        bts2rd = fs_info->fat.vol.bpc;
-
-    entries_per_block = bts2rd / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
-
-#if MSDOS_FIND_PRINT
-    printf ("MSFS:[1] nt:%d, cn:%i ebp:%li bts2rd:%li lfne:%d nl:%i n:%s\n",
-            name_type, create_node, entries_per_block, bts2rd,
-            lfn_entries, name_len, name);
-#endif
+    uint32_t                             *dir_offset,
+    uint32_t                             *empty_space_offset,
+    uint32_t                             *empty_space_entry,
+    uint32_t                             *empty_space_count)
+{
+    int               rc                = RC_OK;
+    ssize_t           bytes_read;
+    uint32_t          dir_entry;
+    fat_pos_t         lfn_start;
+    uint8_t           lfn_checksum      = 0;
+    bool              entry_matched       = false;
+    bool              empty_space_found = false;
+    uint32_t          entries_per_block = bts2rd / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE;
+    int               lfn_entry         = 0;
+    uint8_t           entry_utf8_normalized[(MSDOS_LFN_LEN_PER_ENTRY + 1 ) * MSDOS_NAME_LFN_BYTES_PER_CHAR * MSDOS_NAME_MAX_UTF8_BYTES_PER_CHAR/*MSDOS_ENTRY_LFN_UTF8_BYTES*/];
+    size_t            bytes_in_entry;
+    bool              filename_matched  = false;
+    ssize_t           filename_size_remaining = name_len_for_compare;
+    rtems_dosfs_convert_control *converter = fs_info->converter;
+
     /*
      * Scan the directory seeing if the file is present. While
@@ -1004,20 +1275,24 @@
      * create the entry if the name is not found.
      */
-    while ((ret = fat_file_read(&fs_info->fat, fat_fd, (dir_offset * bts2rd),
-                                bts2rd, fs_info->cl_buf)) != FAT_EOF)
+
+    lfn_start.cln = lfn_start.ofs = FAT_FILE_SHORT_NAME;
+
+    while (   (bytes_read = fat_file_read (&fs_info->fat, fat_fd, (*dir_offset * bts2rd),
+                                             bts2rd, fs_info->cl_buf)) != FAT_EOF
+           && rc == RC_OK)
     {
         bool remainder_empty = false;
 #if MSDOS_FIND_PRINT
-        printf ("MSFS:[2] dir_offset:%li\n", dir_offset);
-#endif
-
-        if (ret < MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
+        printf ("MSFS:[2] dir_offset:%li\n", *dir_offset);
+#endif
+
+        if (bytes_read < MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
             rtems_set_errno_and_return_minus_one(EIO);
 
-        assert(ret == bts2rd);
+        assert(bytes_read == bts2rd);
 
         /* have to look at the DIR_NAME as "raw" 8-bit data */
         for (dir_entry = 0;
-             dir_entry < bts2rd;
+             dir_entry < bts2rd && rc == RC_OK && (! filename_matched);
              dir_entry += MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE)
         {
@@ -1026,5 +1301,5 @@
             /*
              * See if the entry is empty or the remainder of the directory is
-             * empty ? Localise to make the code read better.
+             * empty ? Localize to make the code read better.
              */
             bool entry_empty = (*MSDOS_DIR_ENTRY_TYPE(entry) ==
@@ -1034,5 +1309,5 @@
 #if MSDOS_FIND_PRINT
             printf ("MSFS:[3] re:%i ee:%i do:%li de:%li(%ld)\n",
-                    remainder_empty, entry_empty, dir_offset,
+                    remainder_empty, entry_empty, *dir_offset,
                     dir_entry, (dir_entry / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE));
 #endif
@@ -1044,8 +1319,8 @@
              * is a count of empty entries.
              */
-            if (empty_space_count == 0)
+            if (*empty_space_count == 0)
             {
-                empty_space_entry = dir_entry;
-                empty_space_offset = dir_offset;
+                *empty_space_entry = dir_entry;
+                *empty_space_offset = *dir_offset;
             }
 
@@ -1060,5 +1335,5 @@
                  */
                 if (!create_node)
-                    return MSDOS_NAME_NOT_FOUND_ERR;
+                    rc = MSDOS_NAME_NOT_FOUND_ERR;
 
                 /*
@@ -1068,11 +1343,12 @@
                  * are needed FAT_EOF is returned by the read and we extend the file.
                  */
-                if (!empty_space_found)
+                if (   !empty_space_found
+                    && rc == RC_OK )
                 {
-                  empty_space_count +=
+                    *empty_space_count +=
                     entries_per_block - (dir_entry / MSDOS_DIRECTORY_ENTRY_STRUCT_SIZE);
-                  empty_space_found = true;
-#if MSDOS_FIND_PRINT
-                  printf ("MSFS:[3.2] esf:%i esc%i\n", empty_space_found, empty_space_count);
+                    empty_space_found = true;
+#if MSDOS_FIND_PRINT
+                    printf ( "MSFS:[3.2] esf:%i esc%"PRIu32"\n", empty_space_found, *empty_space_count );
 #endif
                 }
@@ -1083,15 +1359,15 @@
                 if (create_node)
                 {
-                  /*
-                   * Remainder is not empty so is this entry empty ?
-                   */
-                  empty_space_count++;
-
-                  if (empty_space_count == (lfn_entries + 1))
-                    empty_space_found = true;
+                    /*
+                     * Remainder is not empty so is this entry empty ?
+                     */
+                    (*empty_space_count)++;
+
+                    if (*empty_space_count == (fat_entries + 1))
+                        empty_space_found = true;
                 }
 #if MSDOS_FIND_PRINT
                 printf ("MSFS:[4.1] esc:%li esf:%i\n",
-                        empty_space_count, empty_space_found);
+                        *empty_space_count, empty_space_found);
 #endif
             }
@@ -1106,6 +1382,6 @@
                 if (create_node && !empty_space_found)
                 {
-                    empty_space_entry = 0;
-                    empty_space_count = 0;
+                    *empty_space_entry = 0;
+                    *empty_space_count = 0;
                 }
 
@@ -1117,7 +1393,5 @@
                     MSDOS_ATTR_LFN)
                 {
-                    char* p;
-                    int   o;
-                    int   i;
+/*                    int   o;*/
 #if MSDOS_FIND_PRINT
                     printf ("MSFS:[4.2] lfn:%c entry:%i checksum:%i\n",
@@ -1132,5 +1406,5 @@
                     if (lfn_start.cln == FAT_FILE_SHORT_NAME)
                     {
-                        lfn_matched = false;
+                        entry_matched = false;
 
                         /*
@@ -1149,5 +1423,5 @@
                          * on when the characters are checked.
                          */
-                        if (lfn_entries != (*MSDOS_DIR_ENTRY_TYPE(entry) &
+                        if (fat_entries != (*MSDOS_DIR_ENTRY_TYPE(entry) &
                                             MSDOS_LAST_LONG_ENTRY_MASK))
                             continue;
@@ -1156,12 +1430,12 @@
                          * Get the checksum of the short entry.
                          */
-                        lfn_start.cln = dir_offset;
+                        lfn_start.cln = *dir_offset;
                         lfn_start.ofs = dir_entry;
-                        lfn_entry = lfn_entries;
+                        lfn_entry = fat_entries;
                         lfn_checksum = *MSDOS_DIR_LFN_CHECKSUM(entry);
 
 #if MSDOS_FIND_PRINT
                         printf ("MSFS:[4.3] lfn_checksum:%i\n",
-                                *MSDOS_DIR_LFN_CHECKSUM(entry));
+                                lfn_checksum);
 #endif
                     }
@@ -1183,62 +1457,38 @@
                         continue;
                     }
-
+#if MSDOS_FIND_PRINT
+                    printf ("MSFS:[5] lfne:%i\n", lfn_entry);
+#endif
                     lfn_entry--;
-                    o = lfn_entry * MSDOS_LFN_LEN_PER_ENTRY;
-                    p = entry + 1;
-
-#if MSDOS_FIND_PRINT
-                    printf ("MSFS:[5] lfne:%i\n", lfn_entry);
-#endif
-                    for (i = 0; i < MSDOS_LFN_LEN_PER_ENTRY; i++)
-                    {
-#if MSDOS_FIND_PRINT > 1
-                        printf ("MSFS:[6] o:%i i:%i *p:%c(%02x) name[o + i]:%c(%02x)\n",
-                                o, i, *p, *p, name[o + i], name[o + i]);
-#endif
-                        if (*p == '\0')
-                        {
-                            /*
-                             * If this is the first entry, ie the last part of the
-                             * long file name and the length does not match then
-                             * the file names do not match.
-                             */
-                            if (((lfn_entry + 1) == lfn_entries) &&
-                                ((o + i) != name_len))
-                                lfn_start.cln = FAT_FILE_SHORT_NAME;
-                            break;
+
+                    bytes_in_entry = msdos_long_entry_to_utf8_name (
+                        converter,
+                        entry,
+                        (lfn_entry + 1) == fat_entries,
+                        &entry_utf8_normalized[0],
+                        sizeof (entry_utf8_normalized));
+                    if (bytes_in_entry > 0) {
+                        filename_size_remaining = msdos_compare_entry_against_filename (
+                            converter,
+                            &entry_utf8_normalized[0],
+                            bytes_in_entry,
+                            &filename_converted[0],
+                            filename_size_remaining,
+                            &entry_matched);
+
+                        if (filename_size_remaining < 0
+                            || (! entry_matched)) {
+                            filename_size_remaining = name_len_for_compare;
+                            lfn_start.cln = FAT_FILE_SHORT_NAME;
                         }
-
-                        if (((o + i) >= name_len) || (*p != name[o + i]))
-                        {
-                            lfn_start.cln = FAT_FILE_SHORT_NAME;
-                            break;
-                        }
-
-                        switch (i)
-                        {
-                            case 4:
-                                p += 5;
-                                break;
-                            case 10:
-                                p += 4;
-                                break;
-                            default:
-                                p += 2;
-                                break;
-                        }
+                    } else {
+                      lfn_start.cln = FAT_FILE_SHORT_NAME;
+                      entry_matched   = false;
                     }
-
-                    lfn_matched = ((lfn_entry == 0) &&
-                                   (lfn_start.cln != FAT_FILE_SHORT_NAME));
-
-#if MSDOS_FIND_PRINT
-                    printf ("MSFS:[8.1] lfn_matched:%i\n", lfn_matched);
-#endif
                 }
                 else
                 {
 #if MSDOS_FIND_PRINT
-                    printf ("MSFS:[9.1] SFN entry, lfn_matched:%i\n", lfn_matched);
+                    printf ("MSFS:[9.1] SFN entry, entry_matched:%i\n", entry_matched);
 #endif
                     /*
@@ -1250,5 +1500,5 @@
                      * name entry.
                      */
-                    if (lfn_matched)
+                    if (entry_matched)
                     {
                         uint8_t  cs = 0;
